Index: issm/branches/trunk-jpl-damage/scripts/DownloadExternalPackage.py
===================================================================
--- issm/branches/trunk-jpl-damage/scripts/DownloadExternalPackage.py	(revision 12877)
+++ issm/branches/trunk-jpl-damage/scripts/DownloadExternalPackage.py	(revision 12878)
@@ -2,36 +2,60 @@
 # -*- coding: ISO-8859-1 -*-
 
-import os,sys
+import os,sys,re
 import urllib
+from HTMLParser import HTMLParser
+from urllib import FancyURLopener
 
-#Check inputs
-if(len(sys.argv)!=3): raise NameError('usage: ./DownloadExternalPackage.py URL localfile')
+# Start class myHTMLParser
+class MyHTMLParser(HTMLParser):
 
-url=sys.argv[1];
+    def __init__(self, pattern):
+        HTMLParser.__init__(self)
+        self.matcher = re.compile(pattern) 
+        self.targets = []
+
+    def handle_starttag(self, tag, attrs):
+        for i in attrs:
+            if "href" == i[0] and str(self.matcher.match(i[1])) != "None":
+                self.targets.append(i[1])
+# End class myHTMLParser
+
+pivot = sys.argv[1].rfind("/")
+url = (sys.argv[1])[:pivot]
 localFile=sys.argv[2]
 
-#Remove file if it already exists
-if os.path.exists(localFile):
-	print "File "+ localFile +" already exists and will not be downloaded..."
-	sys.exit()
+pivot += 1;
+find = (sys.argv[1])[pivot:];
+print "Looking for " + find
+pattern = find + "[\w.-]*(\.tar\.gz|tar\.gz2|tgz|zip|exe)?"
+parser = MyHTMLParser(pattern)
 
-#Try to download from url
-httpfail=-1
-try:
-	print "Fetching %s" % localFile
-	urllib.urlretrieve(url,localFile)
-	httpfail=0
-except Exception, e:
-	httpfail=1
+urlObject = FancyURLopener()
+obj = urlObject.open(url)
+parser.feed(obj.read())
 
-#Error message in case it failed
-if (httpfail):
-	failureMessage = '''
-===========================================================================
-Unable to download package %s from: %s
-* If URL specified manually - perhaps there is a typo?
-* If your network is disconnected - please reconnect 
-* Alternatively, you can download the above URL manually
-===========================================================================
-''' % (localFile,url)
-	raise RuntimeError(failureMessage)
+if len(parser.targets) > 1:
+    print "Could not resolve your download due to the number of hits."
+    print "Refine your search."
+    for i in parser.targets:
+        print i
+
+elif len(parser.targets) == 1:
+    url += "/" + parser.targets[0]
+    if os.path.exists(localFile): 
+        print "File "+ localFile +" already exists and will not be downloaded..."
+    elif parser.targets[0] == localFile:
+        urllib.urlretrieve(url, localFile)
+        print "Found: " + parser.targets[0]
+    elif parser.matcher.match(localFile) != "None":
+        urllib.urlretrieve(url,parser.targets[0]);
+        print "Found: " + parser.targets[0]
+    else:
+        urllib.urlretrieve(url, parser.targets[0]);
+        print "WARNING: the file found \'" + parser.targets[0] + "\' does not match \'" + localFile + "\'"
+        print "Ensure the downloaded version is suitable."
+
+else:
+    print "No matches found!"
+
+obj.close()
Index: issm/branches/trunk-jpl-damage/scripts/automakererun.sh
===================================================================
--- issm/branches/trunk-jpl-damage/scripts/automakererun.sh	(revision 12877)
+++ issm/branches/trunk-jpl-damage/scripts/automakererun.sh	(revision 12878)
@@ -3,39 +3,9 @@
 #  archive.
 
+# As it turns out, the autoreconf script provided by Autotools
+# encompasses the functionality of this script. As such, the 
+# following two lines will replace the remainder of the script.
+# If all goes well, then the script will be shortened in the future.
 
- ACLOCAL="$ISSM_DIR/externalpackages/automake/install/bin/aclocal"
-AUTOCONF="$ISSM_DIR/externalpackages/autoconf/install/bin/autoconf"
-AUTOHEAD="$ISSM_DIR/externalpackages/autoconf/install/bin/autoheader"
-AUTOMAKE="$ISSM_DIR/externalpackages/automake/install/bin/automake"
-
-echo "removing config.cach"
-rm -rf config.cach
-rm -rf aclocal.m4
-
-if [ ! -f "$ACLOCAL" ]
-then echo "issm aclocal not found, calling default aclocal" 
-	aclocal -I m4
-else echo "Calling aclocal" 
-	$ACLOCAL -I m4
-fi
-
-if [ ! -f "$AUTOCONF" ]
-then echo "issm autoconf not found, calling default aclocal" 
-	autoconf
-else echo "Calling autoconf" 
-	$AUTOCONF
-fi
-
-if [ ! -f "$AUTOHEAD" ]
-then echo "issm autoheader not found, calling default aclocal" 
-	autoheader
-else echo "Calling autoheader" 
-	$AUTOHEAD
-fi
-
-if [ ! -f "$AUTOMAKE" ]
-then echo "issm automake  not found, calling default aclocal" 
-	automake
-else echo "Calling automake " 
-	$AUTOMAKE -a
-fi
+cd $ISSM_DIR
+autoreconf -iv -I m4
Index: issm/branches/trunk-jpl-damage/scripts/getloc.sh
===================================================================
--- issm/branches/trunk-jpl-damage/scripts/getloc.sh	(revision 12877)
+++ issm/branches/trunk-jpl-damage/scripts/getloc.sh	(revision 12878)
@@ -1,5 +1,5 @@
 #!/bin/bash
 #get number of lines of code
-cloc-1.55.pl $ISSM_DIR/src $ISSM_DIR/m4 --exclude-dir=.svn --exclude-ext=exp --exclude-lang=make --out=temp
+cloc-1.55.pl $ISSM_DIR/src $ISSM_DIR/m4 --exclude-dir=.svn --exclude-dir=ad  --exclude-dir=android --exclude-ext=exp --exclude-lang=make --out=temp
 cat temp
 ./cloc2html.py
Index: issm/branches/trunk-jpl-damage/scripts/report.sh
===================================================================
--- issm/branches/trunk-jpl-damage/scripts/report.sh	(revision 12877)
+++ issm/branches/trunk-jpl-damage/scripts/report.sh	(revision 12878)
@@ -19,4 +19,5 @@
 #Process matlab_log.log
 cat matlab_log.log        | egrep 'ERROR|SUCCESS|FAILURE' | grep -v "PETSC" | sed -e "s/>/\&gt;/g" | sed -e "s/</\&lt;/g" > matlab.log
+cat matlab.log        | grep -v "SUCCESS" > matlab_short.log
 cat matlab_log.log        | grep "PETSC" | sed -e "s/>/\&gt;/g" | sed -e "s/</\&lt;/g" > petscerror.log
 NUM_TOT=`wc -l matlab.log | awk '{print $1}'`
@@ -48,10 +49,19 @@
 BODY_FONTL=`echo $BODY_FONT | sed -e "s/style=\"/style=\"text-align:left; /g"`
 
-#create some variables
-if [ $(ls -1 $ISSM_DIR/bin | wc -l) -le 20 ];
-then
+#Did installation work?
+if [ $(ls -1 $ISSM_DIR/bin | wc -l) -le 20 ]; then
 	IS_INSTALL=0
 else
 	IS_INSTALL=1
+fi
+
+#display table ONLY if installation worked and there has been at leat one FAILURE or ERROR
+IS_TABLE=0
+if [ $IS_INSTALL -eq 1 ]; then
+	if [ $NUM_TOT -gt 1 ]; then
+		if [ $NUM_SUC -ne $NUM_TOT  ]; then
+			IS_TABLE=1
+		fi
+	fi
 fi
 
@@ -96,7 +106,7 @@
 
 #update status
-if [ $IS_INSTALL -eq 1 ]
-then
-	if [ $CRASH -eq 0 ]
+if [ $IS_INSTALL -eq 1 ];
+then
+	if [ $CRASH -eq 0 ];
 	then
 		cat summary.html | sed -e "s/STATUS/<span style=\"color:#008000\">all test desks have been run<\/span>/g" > summary2.html
@@ -110,5 +120,5 @@
 
 #report table
-if [ $IS_INSTALL -eq 1 ];
+if [ $IS_TABLE -eq 1 ];
 then
 	cat << END > content.html
@@ -122,5 +132,5 @@
 <th $(echo $BODY_FONT)>Field checked</th>
 </tr>
-$(cat matlab.log | while read line
+$(cat matlab_short.log | while read line
   do
 	  echo "<tr>"
@@ -137,7 +147,7 @@
 		  echo $line | awk -v FONTC="$FONTC" -v FONTL="$FONTL" '
 		  { printf("<td %s id=FAILURE>%s</td>\n<td %s>%s</td>\n<td %s>%s</td>\n<td %s>%s</td>\n<td %s>%s</td>\n\n",FONTL,$1,FONTC,$3,FONTC,$6,FONTL,$9,FONTL,$11);}
-			  '; 
-
-		  else
+		  '; 
+
+	  else
 
 		  #SUCCESS
@@ -146,18 +156,16 @@
 			  FONTC=$(echo "$BODY_FONTC bgcolor=#ddffdd")
 			  FONTL=$(echo "$BODY_FONTL bgcolor=#ddffdd")
+			  #do not write anything
 		  #ERROR
 		  else
 			  FONTC=$(echo "$BODY_FONTC bgcolor=#ffdddd id=ERROR")
 			  FONTL=$(echo "$BODY_FONTL bgcolor=#ffdddd")
+			  echo $line | awk -v FONTC="$FONTC" -v FONTL="$FONTL" '
+			  { printf("<td %s>%s</td>\n<td %s>%s%s%s</td>\n<td %s>%s</td>\n<td %s>%s</td>\n<td %s>%s</td>\n\n",FONTL,$1,FONTL,$3,$4,$5,FONTC,$8,FONTL,$11,FONTL,$13);}
+			  '; 
 		  fi
 
-
-		  echo $line | awk -v FONTC="$FONTC" -v FONTL="$FONTL" '
-		  { printf("<td %s>%s</td>\n<td %s>%s%s%s</td>\n<td %s>%s</td>\n<td %s>%s</td>\n<td %s>%s</td>\n\n",FONTL,$1,FONTL,$3,$4,$5,FONTC,$8,FONTL,$11,FONTL,$13);}
-			  '; 
 	  fi
-
 	  echo "</tr>"
-
   done
 	  )
Index: issm/branches/trunk-jpl-damage/src/Makefile.am
===================================================================
--- issm/branches/trunk-jpl-damage/src/Makefile.am	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/Makefile.am	(revision 12878)
@@ -1,2 +1,2 @@
-EXTRA_DIST =  perl  pro 
-SUBDIRS = c modules m  py
+EXTRA_DIST =  perl  pro  py
+SUBDIRS = c modules m
Index: issm/branches/trunk-jpl-damage/src/ad/todo
===================================================================
--- issm/branches/trunk-jpl-damage/src/ad/todo	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/ad/todo	(revision 12878)
@@ -29,2 +29,16 @@
 amatrix will be used in adolc. pmatrix will be used in Petsc routines. Matrix will 
 have routines to map one into the other.
+
+
+Ad: 
+Eric: 
+Create ISSM namespace.
+Make Matrix Assembly one homogeneous block.
+Make Validation suite for Jean for his prognostic capabilities.
+Jean: 
+typedef all double to ISSM_DOUBLE 
+
+Create an alloc layer with template functions for new and delete.
+Check that the new code  is modular --without-kml, options are up to date.
+
+Replace memcpy, realloc with x layers.  Replace all calls to malloc and free in the code.
Index: issm/branches/trunk-jpl-damage/src/android/ISSM_App/.classpath
===================================================================
--- issm/branches/trunk-jpl-damage/src/android/ISSM_App/.classpath	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/android/ISSM_App/.classpath	(revision 12878)
@@ -0,0 +1,8 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<classpath>
+	<classpathentry kind="src" path="src"/>
+	<classpathentry kind="src" path="gen"/>
+	<classpathentry kind="con" path="com.android.ide.eclipse.adt.ANDROID_FRAMEWORK"/>
+	<classpathentry kind="con" path="com.android.ide.eclipse.adt.LIBRARIES"/>
+	<classpathentry kind="output" path="bin/classes"/>
+</classpath>
Index: issm/branches/trunk-jpl-damage/src/android/ISSM_App/.project
===================================================================
--- issm/branches/trunk-jpl-damage/src/android/ISSM_App/.project	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/android/ISSM_App/.project	(revision 12878)
@@ -0,0 +1,33 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<projectDescription>
+	<name>ISSM_App</name>
+	<comment></comment>
+	<projects>
+	</projects>
+	<buildSpec>
+		<buildCommand>
+			<name>com.android.ide.eclipse.adt.ResourceManagerBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>com.android.ide.eclipse.adt.PreCompilerBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>org.eclipse.jdt.core.javabuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>com.android.ide.eclipse.adt.ApkBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+	</buildSpec>
+	<natures>
+		<nature>com.android.ide.eclipse.adt.AndroidNature</nature>
+		<nature>org.eclipse.jdt.core.javanature</nature>
+	</natures>
+</projectDescription>
Index: issm/branches/trunk-jpl-damage/src/android/ISSM_App/src/issm/app/ISSM_AppActivity.java
===================================================================
--- issm/branches/trunk-jpl-damage/src/android/ISSM_App/src/issm/app/ISSM_AppActivity.java	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/android/ISSM_App/src/issm/app/ISSM_AppActivity.java	(revision 12878)
@@ -0,0 +1,29 @@
+package issm.app;
+
+import android.app.Activity;
+import android.os.Bundle;
+import android.view.View;
+import android.view.View.OnClickListener;
+import android.widget.TextView;
+import android.widget.SeekBar;
+
+public class ISSM_AppActivity extends Activity implements OnClickListener
+{
+	private SeekBar sb;
+	private TextView tv;
+	
+    public void onCreate(Bundle savedInstanceState) 
+    {
+        super.onCreate(savedInstanceState);
+        setContentView(R.layout.main);
+        sb = (SeekBar)findViewById(R.id.seekBar2);
+        tv = (TextView)findViewById(R.id.editText2);
+        tv.setText("Current Progress: " + sb.getProgress());
+        sb.setOnClickListener(this);
+    }
+
+	public void onClick(View v)
+	{
+		tv.setText("Current Progress: " + sb.getProgress());
+	}
+}
Index: issm/branches/trunk-jpl-damage/src/c/Container/Constraints.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Constraints.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Constraints.cpp	(revision 12878)
@@ -4,5 +4,5 @@
  */
 
-/*Headers: {{{1*/
+/*Headers: {{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -25,5 +25,5 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION Constraints::Constraints(){{{1*/
+/*FUNCTION Constraints::Constraints(){{{*/
 Constraints::Constraints(){
 	enum_type=ConstraintsEnum;
@@ -31,5 +31,5 @@
 }
 /*}}}*/
-/*FUNCTION Constraints::~Constraints(){{{1*/
+/*FUNCTION Constraints::~Constraints(){{{*/
 Constraints::~Constraints(){
 	return;
@@ -38,5 +38,5 @@
 
 /*Numerics: */
-/*FUNCTION Constraints::NumberOfConstraints{{{1*/
+/*FUNCTION Constraints::NumberOfConstraints{{{*/
 int Constraints::NumberOfConstraints(void){
 
Index: issm/branches/trunk-jpl-damage/src/c/Container/Constraints.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Constraints.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Constraints.h	(revision 12878)
@@ -21,9 +21,9 @@
 	public:
 
-		/*constructors, destructors: {{{1*/
+		/*constructors, destructors: {{{*/
 		Constraints();
 		~Constraints();
 		/*}}}*/
-		/*numerics: {{{1*/
+		/*numerics: {{{*/
 		int   NumberOfConstraints(void);
 		/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/Container/Container.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Container.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Container.h	(revision 12878)
@@ -6,4 +6,5 @@
 #define  _CONTAINER_CONTAINER_H_
 
+#include "../include/include.h"
 #include "./DataSet.h"
 #include "./Constraints.h"
@@ -17,4 +18,5 @@
 #include "./Results.h"
 #include "./Vertices.h"
+#include "./Observations.h"
 
 #endif //ifndef _CONTAINER_H_
Index: issm/branches/trunk-jpl-damage/src/c/Container/DataSet.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/DataSet.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/DataSet.cpp	(revision 12878)
@@ -4,5 +4,5 @@
  */
 
-/*Headers: {{{1*/
+/*Headers: {{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -11,4 +11,5 @@
 #endif
 
+#include <cstring>
 #include <vector>
 #include <functional>
@@ -17,5 +18,5 @@
 
 #include "./DataSet.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
@@ -27,5 +28,5 @@
 
 /*Constructors/Destructors*/
-/*FUNCTION DataSet::DataSet(){{{1*/
+/*FUNCTION DataSet::DataSet(){{{*/
 DataSet::DataSet(){
 	
@@ -36,5 +37,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::DataSet(int dataset_enum){{{1*/
+/*FUNCTION DataSet::DataSet(int dataset_enum){{{*/
 DataSet::DataSet(int dataset_enum){
 	enum_type=dataset_enum;
@@ -46,5 +47,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::Copy{{{1*/
+/*FUNCTION DataSet::Copy{{{*/
 DataSet*   DataSet::Copy(void){
 
@@ -58,10 +59,10 @@
 	copy->presorted=presorted;
 	if(sorted_ids){
-		copy->sorted_ids=(int*)xmalloc(objects.size()*sizeof(int));
-		memcpy(copy->sorted_ids,sorted_ids,objects.size()*sizeof(int));
+		copy->sorted_ids=xNew<int>(objects.size());
+		xMemCpy<int>(copy->sorted_ids,sorted_ids,objects.size());
 	}
 	if(id_offsets){
-		copy->id_offsets=(int*)xmalloc(objects.size()*sizeof(int));
-		memcpy(copy->id_offsets,id_offsets,objects.size()*sizeof(int));
+		copy->id_offsets=xNew<int>(objects.size());
+		xMemCpy<int>(copy->id_offsets,id_offsets,objects.size());
 	}
 
@@ -76,14 +77,14 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::~DataSet{{{1*/
+/*FUNCTION DataSet::~DataSet{{{*/
 DataSet::~DataSet(){
 	clear();
-	xfree((void**)&sorted_ids);
-	xfree((void**)&id_offsets);
+	xDelete<int>(sorted_ids);
+	xDelete<int>(id_offsets);
 }
 /*}}}*/
 
 /*Specific methods*/
-/*FUNCTION DataSet::AddObject{{{1*/
+/*FUNCTION DataSet::AddObject{{{*/
 int  DataSet::AddObject(Object* object){
 
@@ -93,5 +94,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::clear{{{1*/
+/*FUNCTION DataSet::clear{{{*/
 void  DataSet::clear(){
 
@@ -111,5 +112,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::DeleteObject{{{1*/
+/*FUNCTION DataSet::DeleteObject{{{*/
 int  DataSet::DeleteObject(Object* object){
 
@@ -126,5 +127,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::DeepEcho{{{1*/
+/*FUNCTION DataSet::DeepEcho{{{*/
 void DataSet::DeepEcho(){
 
@@ -132,7 +133,7 @@
 	vector<Object*>::iterator object;
 
-	if(this==NULL)_error_(" trying to echo a NULL dataset");
-
-	_printf_(true,"DataSet echo: %i objects\n",objects.size());
+	if(this==NULL)_error2_("trying to echo a NULL dataset");
+
+	_pprintLine_("DataSet echo: " << objects.size() << " objects");
 
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
@@ -144,12 +145,12 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::Echo{{{1*/
+/*FUNCTION DataSet::Echo{{{*/
 void DataSet::Echo(){
 
 	vector<Object*>::iterator object;
 
-	if(this==NULL)_error_(" trying to echo a NULL dataset");
-
-	_printf_(true,"DataSet echo: %i objects\n",objects.size());
+	if(this==NULL)_error2_("trying to echo a NULL dataset");
+
+	_pprintLine_("DataSet echo: " << objects.size() << " objects");
 
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
@@ -162,10 +163,10 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::GetEnum(){{{1*/
+/*FUNCTION DataSet::GetEnum(){{{*/
 int  DataSet::GetEnum(){
 	return enum_type;
 }
 /*}}}*/
-/*FUNCTION DataSet::GetEnum(int offset){{{1*/
+/*FUNCTION DataSet::GetEnum(int offset){{{*/
 int   DataSet::GetEnum(int offset){
 
@@ -174,5 +175,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::GetObjectByOffset{{{1*/
+/*FUNCTION DataSet::GetObjectByOffset{{{*/
 Object* DataSet::GetObjectByOffset(int offset){
 
@@ -185,5 +186,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::GetObjectById{{{1*/
+/*FUNCTION DataSet::GetObjectById{{{*/
 Object* DataSet::GetObjectById(int* poffset,int eid){
 
@@ -193,9 +194,9 @@
 
 	_assert_(this);
-	if(!sorted)_error_(" trying to binary search on a non-sorted dataset!");
+	if(!sorted)_error2_("trying to binary search on a non-sorted dataset!");
 
 	/*Carry out a binary search on the sorted_ids: */
 	if(!binary_search(&id_offset,eid, sorted_ids,objects.size())){
-		_error_("could not find object with id %i in DataSet %s",eid,EnumToStringx(enum_type));
+		_error2_("could not find object with id " << eid << " in DataSet " << EnumToStringx(enum_type));
 	}
 
@@ -210,5 +211,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::Presort{{{1*/
+/*FUNCTION DataSet::Presort{{{*/
 void DataSet::Presort(){
 
@@ -220,10 +221,10 @@
 
 		/*Delete existing ids*/
-		xfree((void**)&sorted_ids);
-		xfree((void**)&id_offsets);
+		xDelete<int>(sorted_ids);
+		xDelete<int>(id_offsets);
 
 		/*Allocate new ids*/
-		sorted_ids=(int*)xmalloc(objects.size()*sizeof(int));
-		id_offsets=(int*)xmalloc(objects.size()*sizeof(int));
+		sorted_ids=xNew<int>(objects.size());
+		id_offsets=xNew<int>(objects.size());
 
 		/*Build id_offsets and sorted_ids*/
@@ -238,5 +239,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::SetSorting{{{1*/
+/*FUNCTION DataSet::SetSorting{{{*/
 void DataSet::SetSorting(int* in_sorted_ids,int* in_id_offsets){
 
@@ -246,5 +247,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::Size{{{1*/
+/*FUNCTION DataSet::Size{{{*/
 int  DataSet::Size(void){
 	_assert_(this!=NULL);
@@ -253,11 +254,11 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::Sort{{{1*/
+/*FUNCTION DataSet::Sort{{{*/
 void DataSet::Sort(){
 
 	/*Only sort if we are not already sorted: */
 	if(!sorted){
-		_error_(" not implemented yet!");
-	}
-}
-/*}}}*/
+		_error2_("not implemented yet!");
+	}
+}
+/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/Container/DataSet.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/DataSet.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/DataSet.h	(revision 12878)
@@ -7,10 +7,9 @@
 
 #include <vector>
-#include "../objects/Object.h"
+#include "../classes/objects/Object.h"
 #include "../toolkits/toolkits.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
 
 /*forward declarations */
-
 class Elements;
 class Loads;
@@ -39,10 +38,10 @@
 		int*            id_offsets;
 
-		/*constructors, destructors: {{{1*/
+		/*constructors, destructors: {{{*/
 		DataSet();
 		DataSet(int enum_type);
 		~DataSet();
 		/*}}}*/
-		/*management: {{{1*/
+		/*management: {{{*/
 		int   GetEnum();
 		int   GetEnum(int offset);
Index: issm/branches/trunk-jpl-damage/src/c/Container/Elements.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Elements.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Elements.cpp	(revision 12878)
@@ -4,5 +4,5 @@
  */
 
-/*Headers: {{{1*/
+/*Headers: {{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -25,5 +25,5 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION Elements::Elements(){{{1*/
+/*FUNCTION Elements::Elements(){{{*/
 Elements::Elements(){
 	enum_type=MeshElementsEnum;
@@ -31,5 +31,5 @@
 }
 /*}}}*/
-/*FUNCTION Elements::~Elements(){{{1*/
+/*FUNCTION Elements::~Elements(){{{*/
 Elements::~Elements(){
 	return;
@@ -38,5 +38,5 @@
 
 /*Object management*/
-/*FUNCTION Elements::Configure{{{1*/
+/*FUNCTION Elements::Configure{{{*/
 void Elements::Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){
 
@@ -53,5 +53,5 @@
 }
 /*}}}*/
-/*FUNCTION Elements::ProcessResultsUnits{{{1*/
+/*FUNCTION Elements::ProcessResultsUnits{{{*/
 void Elements::ProcessResultsUnits(void){
 
@@ -63,5 +63,5 @@
 }
 /*}}}*/
-/*FUNCTION Elements::DeleteResults{{{1*/
+/*FUNCTION Elements::DeleteResults{{{*/
 void Elements::DeleteResults(void){
 	
@@ -72,5 +72,5 @@
 }
 /*}}}*/
-/*FUNCTION Elements::ResultsToPatch{{{1*/
+/*FUNCTION Elements::ResultsToPatch{{{*/
 Patch* Elements::ResultsToPatch(void){ 
 
@@ -148,5 +148,5 @@
 }
 /*}}}*/
-/*FUNCTION Elements::SetCurrentConfiguration{{{1*/
+/*FUNCTION Elements::SetCurrentConfiguration{{{*/
 void Elements::SetCurrentConfiguration(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){
 
@@ -163,5 +163,5 @@
 }
 /*}}}*/
-/*FUNCTION Elements::ToResults{{{1*/
+/*FUNCTION Elements::ToResults{{{*/
 void Elements::ToResults(Results* results,Parameters* parameters){
 
@@ -173,6 +173,6 @@
 	int    *resultssizes  = NULL;
 	int    *resultssteps  = NULL;
-	double *resultstimes = NULL;
-	double *vector_serial= NULL;
+	IssmDouble *resultstimes = NULL;
+	IssmDouble *vector_serial= NULL;
 	Vector*     vector       = NULL;
 	bool   io_gather;
@@ -203,5 +203,5 @@
 		/*see what the first element of this partition has in stock (this is common to all partitions)*/
 		if(my_rank==minrank){
-			if(this->Size()==0) _error_("Cannot write results because there is no element??");
+			if(this->Size()==0) _error2_("Cannot write results because there is no element??");
 			Element* element=(Element*)this->GetObjectByOffset(0);
 			element->ListResultsInfo(&resultsenums,&resultssizes,&resultstimes,&resultssteps,&numberofresults);
@@ -215,8 +215,8 @@
 		#ifdef _HAVE_MPI_
 		if(my_rank!=minrank){
-			resultsenums=(int*)xmalloc(numberofresults*sizeof(int));
-			resultssizes=(int*)xmalloc(numberofresults*sizeof(int));
-			resultstimes=(double*)xmalloc(numberofresults*sizeof(double));
-			resultssteps=(int*)xmalloc(numberofresults*sizeof(int));
+			resultsenums=xNew<int>(numberofresults);
+			resultssizes=xNew<int>(numberofresults);
+			resultstimes=xNew<IssmDouble>(numberofresults);
+			resultssteps=xNew<int>(numberofresults);
 		}
 		MPI_Bcast(resultsenums,numberofresults,MPI_INT,minrank,MPI_COMM_WORLD);
@@ -232,10 +232,10 @@
 			if(resultssizes[i]==P1Enum)      vectorsize=numberofvertices;
 			else if(resultssizes[i]==P0Enum) vectorsize=numberofelements;
-			else _error_("Unkown result size: %s",EnumToStringx(resultssizes[i]));
+			else _error2_("Unkown result size: " << EnumToStringx(resultssizes[i]));
 			vector=new Vector(vectorsize);
 
 			for(int j=0;j<this->Size();j++){
 				Element* element=(Element*)this->GetObjectByOffset(j);
-				element->GetVectorFromResults(vector,i,resultssizes[i]);
+				element->GetVectorFromResults(vector,i,resultsenums[i],resultssizes[i]);
 			}
 			vector->Assemble();
@@ -250,5 +250,5 @@
 			/*clean up*/
 			xdelete(&vector);
-			xfree((void**)&vector_serial);
+			xDelete<IssmDouble>(vector_serial);
 		}
 	}
@@ -269,12 +269,12 @@
 
 	/*Free ressources:*/
-	xfree((void**)&resultsenums);
-	xfree((void**)&resultssizes);
-	xfree((void**)&resultstimes);
-	xfree((void**)&resultssteps);
+	xDelete<int>(resultsenums);
+	xDelete<int>(resultssizes);
+	xDelete<int>(resultssteps);
+	xDelete<IssmDouble>(resultstimes);
 	delete patch;
 }
 /*}}}*/
-/*FUNCTION Elements::NumberOfElements{{{1*/
+/*FUNCTION Elements::NumberOfElements{{{*/
 int Elements::NumberOfElements(void){
 
@@ -292,5 +292,5 @@
 }
 /*}}}*/
-/*FUNCTION Elements::InputCopy{{{1*/
+/*FUNCTION Elements::InputCopy{{{*/
 void Elements::InputDuplicate(int input_enum,int output_enum){
 
Index: issm/branches/trunk-jpl-damage/src/c/Container/Elements.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Elements.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Elements.h	(revision 12878)
@@ -16,14 +16,13 @@
 class Inputs;
 
-
 class Elements: public DataSet{
 
 	public:
 
-		/*constructors, destructors: {{{1*/
+		/*constructors, destructors: {{{*/
 		Elements();
 		~Elements();
 		/*}}}*/
-		/*numerics: {{{1*/
+		/*numerics: {{{*/
 		void Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
 		void DeleteResults(void);
